# wire.js Reference

1. [Introduction](introduction.md)
	1. [Features](introduction.md#features)
	1. [Examples](introduction.md#example-apps)
1. [Getting wire.js](get.md)
1. [Concepts](concepts.md)
	1. [Inversion of Control](concepts.md#inversion-of-control)
	1. [Dependency Inversion](concepts.md#dependency-inversion)
	1. [Application Composition](concepts.md#application-composition)
	1. [Wire-specific Concepts](concepts.md#wire-concepts)
1. [Creating Components](components.md)
	1. [Simple Types](components.md#simple-types)
	1. [Application Components](components.md#application-components)
	1. [Built-in Factories](components.md#built-in-factories)
1. [Configuring Components](configure.md)
	1. [Properties](configure.md#properties)
	1. [Init Methods](configure.md#init-methods)
	1. [Ready Methods](configure.md#ready-methods)
	1. [Destroy Methods](configure.md#destroy-methods)
1. [Connecting Components](connections.md)
	1. [Dependency Injection](connections.md#dependency-injection)
	1. [DOM Events](connections.md#dom-events)
	1. [Javascript to Javascript](connections.md#javascript-to-javascript)
	1. [Aspect Oriented Programming (AOP)](connections.md#aspect-oriented-programming-aop)
	1. [Promise-aware AOP](connections.md#promise-aware-aop)
	1. [Transform Connections](connections.md#transform-connections)
1. [Working with Functions](functions.md)
	1. [Functions as Components](functions.md#functions-as-components)
	1. [Injecting Functions](functions.md#injecting-functions)
	1. [Connecting to Functions](functions.md#connecting-to-functions)
	1. [Transform Connections](functions.md#transform-connections)
1. [Working with the DOM](dom.md)
	1. [Querying the DOM](dom.md#querying-the-dom)
	1. [Cloning DOM nodes](dom.md#cloning-dom-nodes)
	1. [Inserting DOM nodes](dom.md#inserting-dom-nodes)
	1. [Connecting DOM events](dom.md#connecting-dom-events)
	1. [Rendering DOM elements](dom.md#rendering-dom-elements)
	1. [Notes on DOMReady](dom.md#notes-on-domready)
